
#property indicator_chart_window
#property indicator_buffers 2

input bool MarkByOpen = true;
input bool MarkByTime = false;
input int HourMarked = 0;
input int MinuteMarked = 0;
input color BarColorUp = Blue;
input color BarColorDown = Red; 



double bufferOpen[], bufferClose[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
void OnInit(void)
  {
   
//--- indicator lines
   SetIndexStyle(0,DRAW_HISTOGRAM,0,4,BarColorUp);  // Color0 => Index 0 > Index 1  
   SetIndexBuffer(0,bufferClose);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,4,BarColorDown);  // Color1 ==> Index 1 > Index 0 
   SetIndexBuffer(1,bufferOpen);
   

//--- initialization done
  }


int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
     
   ArrayInitialize(bufferClose,0.0);
   ArrayInitialize(bufferOpen,0.0);
     
   for(int i=0; i<rates_total-1; i++)
     {
         if ( TimeHour(Time[i])==HourMarked && TimeMinute(Time[i])==MinuteMarked && MarkByTime )
         {
         
            bufferClose[i] = Close[i];
            bufferOpen[i] = Open[i]; 
           
         }
         
         if ( Time[i]-Time[i+1]>4*60*60 && MarkByOpen )
         {
         
            bufferClose[i] = Close[i];
            bufferOpen[i] = Open[i]; 
           
         }
     }
     
   
   
           
//--- done
   return(rates_total);
  }
//+------------------------------------------------------------------+
